;Sample POOL code, you may use it, modify it
;and distribute it under the GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

window      ;enable drawing outside the graphics window
hideturtle  ;hide turtle's icon
:pool_cfg,"refresh := false ;disable automatic refresh of graphics
:pool_cfg,"scale_x := 50    ;horizontal drawing scale
:pool_cfg,"scale_y := 50    ;vertical drawing scale

;Draws a function f(x) which formula is given as a list in
;the argument :fn, in the range from :x0 to :x1. Function
;values are calculated in :npt uniformly distributed points.
to draw :fn :x0 :x1 :npt
  clean
  let "b true ;protection against calculation out of fn domain
  let "x :x0
  let "y run :fn    ;*** y = fn(x) ***
  if !validnum? :y ["y := 0 "b := false]
  penup setxy :x :y
  for [x :x0 :x1 [(:x1 - :x0) / :npt]] [
    "y := run :fn   ;*** y = fn(x) ***
    ifelse validnump :y [
      if :b [pendown]
      setxy :x :y
      "b := true
    ] [
      penup setxy :x 0
      "b := false
    ]
  ]
  refresh ;refresh graphics when drawing done
end

;Handling function for changes in position of the graphics window
;edges, occurs when window is resized or scrolled.
to onworldchanged :walls
  draw parse gettext :eq :walls,1 :walls,2 500
end

"eq := textbox "|radsin :x| {10 4 200 24} ;function formula

"go := (button "Draw {212 4 70 24} [ ;button to start
  draw parse gettext :eq  ~
  :pool_inf,"wall_left ~
  :pool_inf,"wall_right 500
])

